{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE DeriveGeneric #-}

-- | Contains the types generated from the schema InvoiceSettingSubscriptionScheduleSetting
module StripeAPI.Types.InvoiceSettingSubscriptionScheduleSetting where

import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Functor
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Generics
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common

-- | Defines the data type for the schema invoice_setting_subscription_schedule_setting
-- 
-- 
data InvoiceSettingSubscriptionScheduleSetting = InvoiceSettingSubscriptionScheduleSetting {
  -- | days_until_due: Number of days within which a customer must pay invoices generated by this subscription schedule. This value will be \`null\` for subscription schedules where \`billing=charge_automatically\`.
  invoiceSettingSubscriptionScheduleSettingDaysUntilDue :: (GHC.Maybe.Maybe GHC.Integer.Type.Integer)
  } deriving (GHC.Show.Show
  , GHC.Classes.Eq)
instance Data.Aeson.ToJSON InvoiceSettingSubscriptionScheduleSetting
    where toJSON obj = Data.Aeson.object ((Data.Aeson..=) "days_until_due" (invoiceSettingSubscriptionScheduleSettingDaysUntilDue obj) : [])
          toEncoding obj = Data.Aeson.pairs ((Data.Aeson..=) "days_until_due" (invoiceSettingSubscriptionScheduleSettingDaysUntilDue obj))
instance Data.Aeson.Types.FromJSON.FromJSON InvoiceSettingSubscriptionScheduleSetting
    where parseJSON = Data.Aeson.Types.FromJSON.withObject "InvoiceSettingSubscriptionScheduleSetting" (\obj -> GHC.Base.pure InvoiceSettingSubscriptionScheduleSetting GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:? "days_until_due"))